
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the VCI_CAN_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// VCI_CAN_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef VCI_CAN_EXPORTS
#define _EXP __declspec(dllexport)
#else
#define _EXP __declspec(dllimport)
#endif

BYTE StartHB;
HANDLE  Socket_Thread;
HANDLE  CAN_RxThread;
HANDLE  CAN_TxThread;

#define WIFI_BUF_SIZE		16384
#define WIFI_TxBUF_SIZE		16384

//WIFI
typedef struct
{
	char buf [22];     // Buffer
} WIFI_TXBuf;

//CAN
typedef struct
{
    unsigned long ulType;			// Frame Type
    unsigned long ulDL;	        	// Data Length
	unsigned long ulRTR;			// RTR
	unsigned long ulMsgID;	    	// CAN Message ID (11-bit or 29-bit)
	unsigned long ulDataL;	    	// CAN Message Data Bytes 0-3
	unsigned long ulDataH;			// CAN Message Data Bytes 4-7
	unsigned long ulTimeH;		    // CAN Message Time Stamp
	unsigned long ulTimeL;		    // CAN Message Time Stamp
} CANS_MSG;

#define CAN_BUF_SIZE		65536
#define CAN_BUF_MASK		(CAN_BUF_SIZE-1ul)

extern BYTE WIFIBuf_RX[WIFI_BUF_SIZE];
extern WIFI_TXBuf WIFIBuf_TX[WIFI_TxBUF_SIZE];
extern DWORD WIFISOC_TX[WIFI_TxBUF_SIZE];
extern volatile DWORD WIFIR_RxCnt, WIFIR_TxCnt, WIFIT_RxCnt, WIFIT_TxCnt;
extern volatile BYTE WIFIR_BufFull, WIFIT_BufFull;

extern CANS_MSG MsgBuf_RX1[CAN_BUF_SIZE];
extern volatile DWORD CANO_TxCnt, CANO_RxCnt, CANR_TxCnt, CANR_RxCnt;
extern volatile BYTE CAN1BufFull;

#define WIFIR_BUF_MASK	   (WIFI_BUF_SIZE-1ul)
#define WIFIR_BUF_WRIDX    (WIFIR_BUF_MASK & WIFIR_RxCnt)
#define WIFIR_BUF_RDIDX    (WIFIR_BUF_MASK & WIFIR_TxCnt)
#define WIFIR_BUF_EMPTY    (WIFIR_BUF_RDIDX == WIFIR_BUF_WRIDX)
#define WIFIR_BUF_FULL     (WIFIR_BUF_RDIDX == (WIFIR_BUF_MASK & (WIFIR_RxCnt+1)))
#define WIFIR_BUF_COUNT    (WIFIR_BUF_MASK & (WIFIR_RxCnt - WIFIR_TxCnt))
#define WIFIR_BUF_RD       (WIFIBuf_RX[WIFIR_BUF_MASK & WIFIR_TxCnt])

#define WIFIT_BUF_MASK	   (WIFI_TxBUF_SIZE-1ul)
#define WIFIT_BUF_WRIDX    (WIFIT_BUF_MASK & WIFIT_RxCnt)
#define WIFIT_BUF_RDIDX    (WIFIT_BUF_MASK & WIFIT_TxCnt)
#define WIFIT_BUF_EMPTY    (WIFIT_BUF_RDIDX == WIFIT_BUF_WRIDX)
#define WIFIT_BUF_FULL     (WIFIT_BUF_RDIDX == (WIFIT_BUF_MASK & (WIFIT_RxCnt+1)))
#define WIFIT_BUF_COUNT    (WIFIT_BUF_MASK & (WIFIT_RxCnt - WIFIT_TxCnt))
#define WIFIT_BUF_RD       (WIFIBuf_TX[WIFIT_BUF_MASK & WIFIT_TxCnt])


/* CAN Recv-Data Define */ //WiFiToCAN
#define CANR_BUF_EMPTY      (CANR_TxCnt == CANR_RxCnt)
#define CANR_BUF_FULL       (CANR_TxCnt == (CANR_RxCnt+1))
#define CANR_BUF_COUNT      (CAN_BUF_MASK & (CANR_RxCnt - CANR_TxCnt))
#define CANR_BUF_RD         ( MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt]) 
#define CANR_RXDATA_MODE	((MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt].Frame>>31)&0x1)
#define CANR_RXDATA_RTR		((MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt].Frame>>30)&0x1)
#define CANR_RXDATA_LEN		((MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt].Frame>>16)&0x0F)
#define CANR_RXDATA_ID		( MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt].MsgID)
#define CANR_RXDATA_LW		( MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt].DataA)
#define CANR_RXDATA_HW		( MsgBuf_RX1[CAN_BUF_MASK & CANR_TxCnt].DataB)

#define CANR_BUF_WRIDX_G    (CAN_BUF_MASK & CANR_RxCnt)
#define CANR_BUF_RDIDX_G    (CAN_BUF_MASK & CANR_TxCnt)
#define CANR_BUF_EMPTY_G    (CANR_BUF_RDIDX_G == CANR_BUF_WRIDX_G)
#define CANR_BUF_FULL_G     (CANR_BUF_RDIDX_G == (CAN_BUF_MASK & (CANR_RxCnt+1)))

#define WIFIT_SOC_RD       (WIFISOC_TX[WIFIT_BUF_MASK & WIFIT_TxCnt])


// This class is exported from the VCI_CAN.dll
class _EXP CVCI_CAN {
public:
	CVCI_CAN(void);
	// TODO: add your methods here.

protected:

	BOOL                         mb_RefreshCombo;
	CRITICAL_SECTION             mk_Critical;
};

/***  For BCB ***/
#ifdef	__cplusplus  // for C++ compile use
extern "C" {
#endif	/*	__cplusplus	*/


/* Common Return Code */
#define No_Err						0	//No Error
#define Socket_Busy                 1   //Socket already in use
#define Socket_Timeout              2   //Socket connect timeout
#define Socket_NumErr               3   //Wrong Socket Number
#define CAN_RxBufEmpty				4	//The CAN Receive Buffer is empty
#define CAN_RxBufFull				5	//The CAN Receive Buffer is full
#define TCP_SocketNotOpen_Err	    6	//The Socket doesn't Open

typedef struct packet
{	
	LONGLONG MsgTimeStamps;
	BYTE  mode;
	DWORD id;
	BYTE  rtr;
	BYTE  len;
	BYTE  data[8];
} CANStruct;


/************************      VCI_CAN API Function      *************************/ 

/********************     [2] Other Function     ********************/
_EXP	DWORD __stdcall I7540DWF_Get_DllVer(void);
_EXP	void  __stdcall I7540DWF_DoEvents(void);

/********************     [1] Socket Function     ********************/
BOOL  SendTo(DWORD u32_Index, char*  s8_Data, DWORD u32_Len);
_EXP	void  __stdcall I7540DWF_CloseSockets();
_EXP	DWORD __stdcall I7540DWF_ServerListen(DWORD u32_IP, unsigned short ms32_Port);
_EXP	DWORD __stdcall I7540DWF_ClientConnect(DWORD u32_IP, unsigned short ms32_Port);
_EXP	int   __stdcall I7540DWF_SendCANMsg(DWORD h_Socket, CANStruct TxCanPacket);
_EXP	int   __stdcall I7540DWF_SendCANMsg_NoStruct(DWORD h_Socket, BYTE mode, BYTE rtr, BYTE len, DWORD id, BYTE data[8]);
_EXP	int   __stdcall I7540DWF_RecvCANMsg(CANStruct *RxCanPacket);
_EXP	int   __stdcall I7540DWF_RecvCANMsg_NoStruct(BYTE* mode, DWORD* id, BYTE* rtr, BYTE* len, BYTE data[8], LONGLONG* MsgTimeStamps);
_EXP	DWORD __stdcall I7540DWF_Get_RxMsgCnt(void);
_EXP	int __stdcall   I7540DWF_Get_CntStatus(void);


/***  For BCB ***/
#ifdef	__cplusplus
}
#endif	/*	__cplusplus	*/

